local L = LibStub("AceLocale-3.0"):GetLocale("JeypLoathebHealSorter")
local LSM = LibStub( "LibSharedMedia-3.0" )
local MAX_HEALER_COUNT = 15

function JeypLoathebHealSorter:OnDragStop()
	self.db.global.tFramePosition.fX = JeypLoathebHealSorter_Frame:GetLeft()
	self.db.global.tFramePosition.fY = -(JeypLoathebHealSorter_Frame:GetParent():GetHeight() - JeypLoathebHealSorter_Frame:GetTop())
end

function JeypLoathebHealSorter:OnFrameLoad()
	self.fPaddingOut = 1
	self.fPaddingIn = 1
	self.fPadding = self.fPaddingOut + self.fPaddingIn
	self.fDelayUntilColorFade = 2
	self.fDelayUntilFadeout = 10
	self.fTimeLastShow = 0
	
	JeypLoathebHealSorter_Frame:Show()
	JeypLoathebHealSorter_Frame.tTextTitle = JeypLoathebHealSorter_Frame:CreateFontString("JeypLoathebHealSorter_Frame_Title_Text_", 'ARTWORK', "GameFontNormal");
	JeypLoathebHealSorter_Frame.tTextTitle:SetWordWrap(false)
	JeypLoathebHealSorter_Frame.tTextTitle:SetTextHeight(20)
	JeypLoathebHealSorter_Frame.tTextTitle:SetSize(JeypLoathebHealSorter_Frame:GetWidth(), 20);	
	JeypLoathebHealSorter_Frame.tTextTitle:SetPoint("TOP",JeypLoathebHealSorter_Frame,"TOP", 10, 0);	
	JeypLoathebHealSorter_Frame.tTextTitle:SetText("JeypLoathebHealSorter", 0, 0)
	JeypLoathebHealSorter_Frame.tTextTitle:SetJustifyH("CENTER")
	JeypLoathebHealSorter_Frame.tTextTitle:SetJustifyV("CENTER")
	
	local fHeight = 20
	JeypLoathebHealSorter_Frame.tHealersFrames = {}
	fHeight = fHeight + 10
	
	
	JeypLoathebHealSorter_Frame:SetHeight(fHeight)	
	self.tHealerList = {}
	self.Frame = JeypLoathebHealSorter_Frame
	
	JeypLoathebHealSorter_Frame.bInit = true
end

function JeypLoathebHealSorter:UpdateFontSize()
	local fFrameHeight = self.db.global.iFontSize + self.db.global.iMargin
	local fMaxStaticWidth = 0
	local fMaxPlayerWidth = 0
	JeypLoathebHealSorter_Frame.tTextTitle:SetTextHeight(self.db.global.iFontSize)
	fFrameHeight = fFrameHeight + JeypLoathebHealSorter_Frame.tTextTitle:GetStringHeight() + self.db.global.iMargin
	JeypLoathebHealSorter_Frame.tTextTitle:SetSize(JeypLoathebHealSorter_Frame:GetWidth(), self.db.global.iFontSize);

	for i = 1, self.db.global.iHealersToDisplay do 
		JeypLoathebHealSorter_Frame.tHealersFrames[i].ClassFrame:SetSize(self.db.global.iFontSize + (self.fPadding * 2), self.db.global.iFontSize + (self.fPadding * 2));
		JeypLoathebHealSorter_Frame.tHealersFrames[i].tTexClassIcon:SetSize(self.db.global.iFontSize, self.db.global.iFontSize);
		JeypLoathebHealSorter_Frame.tHealersFrames[i].SporeFrame:SetSize(self.db.global.iFontSize + (self.fPadding * 2), self.db.global.iFontSize + (self.fPadding * 2));
		JeypLoathebHealSorter_Frame.tHealersFrames[i].tTexSporeIcon:SetSize(self.db.global.iFontSize, self.db.global.iFontSize);
		JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic:SetTextHeight(self.db.global.iFontSize)
		JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextPlayer:SetTextHeight(self.db.global.iFontSize)
		fFrameHeight = fFrameHeight + JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic:GetStringHeight() + self.db.global.iMargin
		fMaxStaticWidth = math.max(fMaxStaticWidth, JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic:GetStringWidth() + 2 * self.db.global.iMargin)
		fMaxPlayerWidth = math.max(fMaxPlayerWidth, JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextPlayer:GetStringWidth() + 2 * self.db.global.iMargin)
	end	
	
	local fFrameWidth = fMaxStaticWidth + fMaxPlayerWidth
	fFrameWidth = fFrameWidth + self.db.global.iFontSize + (self.fPadding * 2) -- Add Class Icon Width
	fFrameWidth = fFrameWidth + self.db.global.iFontSize + (self.fPadding * 2) -- Add Spore Icon Width
	fFrameWidth = fFrameWidth + self.db.global.iMargin * 4.0
	JeypLoathebHealSorter_Frame:SetWidth(fFrameWidth)	
	JeypLoathebHealSorter_Frame:SetHeight(fFrameHeight)	
	
	for i = 1, self.db.global.iHealersToDisplay do 
		JeypLoathebHealSorter_Frame.tHealersFrames[i]:SetSize(JeypLoathebHealSorter_Frame:GetWidth(), self.db.global.iFontSize);
		JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic:SetWidth(fMaxStaticWidth  - self.db.global.iMargin)
	end	
end

function JeypLoathebHealSorter:InitHealerFrames()
	local fHeight = self.db.global.iFontSize
	JeypLoathebHealSorter_Frame.tHealersFrames = {}
	fHeight = fHeight + self.db.global.iMargin
	
	fHeight = fHeight + self:ShowHealerFrame(1, JeypLoathebHealSorter_Frame.tTextTitle)
	for i = 2, MAX_HEALER_COUNT do 
		fHeight = fHeight + self:ShowHealerFrame(i, JeypLoathebHealSorter_Frame.tHealersFrames[i-1])
	end
	for i = self.db.global.iHealersToDisplay + 1, MAX_HEALER_COUNT do 
		fHeight = fHeight - self:HideHealerFrame(i)
	end
	
	JeypLoathebHealSorter_Frame:SetHeight(fHeight)	
end

function JeypLoathebHealSorter:HideHealerFrame(iID) 
	if JeypLoathebHealSorter_Frame.tHealersFrames[iID] ~= nil then
		JeypLoathebHealSorter_Frame.tHealersFrames[iID]:Hide()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:Hide()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:Hide()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:Hide()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:Hide()
		return (JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:GetStringHeight() + self.db.global.iMargin)
	end 
	return 0
end

function JeypLoathebHealSorter:UpdateFonts()
	for i = 1, MAX_HEALER_COUNT do 
		if self.db.global.sFont ~= nil then
			JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic:SetFont(LSM:Fetch("font", self.db.global.sFont), self.db.global.iFontSize)
			JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextPlayer:SetFont(LSM:Fetch("font", self.db.global.sFont), self.db.global.iFontSize)
		else
			JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic:SetFontObject(NumberFontNormalSmall)
			JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextPlayer:SetFontObject(NumberFontNormalSmall)
		end
	end
	self:UpdateFontSize()
end

function JeypLoathebHealSorter:ShowHealerFrame(iID, rFrameAnchor)
	if JeypLoathebHealSorter_Frame.tHealersFrames[iID] == nil then
		local sText = "" .. iID
		if iID == 1 then
			sText = sText .. L["st"]
		elseif iID == 2 then 
			sText = sText .. L["nd"]
		elseif iID == 3 then
			sText = sText .. L["rd"]
		else
			sText = sText .. L["th"]
		end
		sText = sText .. " Healer|r :"
	
		JeypLoathebHealSorter_Frame.tHealersFrames[iID] = CreateFrame("Frame", "JeypLoathebHealSorter_Frame_Healer_" .. iID, JeypLoathebHealSorter_Frame)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID]:SetPoint("TOP",rFrameAnchor,"BOTTOM", 0, -self.db.global.iMargin)	
		JeypLoathebHealSorter_Frame.tHealersFrames[iID]:SetSize(JeypLoathebHealSorter_Frame:GetWidth(), self.db.global.iFontSize);
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame = CreateFrame("Frame", "JeypLoathebHealSorter_Frame_" .. iID.."_IconFrame", JeypLoathebHealSorter_Frame.tHealersFrames[iID])
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:SetSize(self.db.global.iFontSize + (self.fPadding * 2), self.db.global.iFontSize + (self.fPadding * 2));
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:SetPoint("TOPLEFT")
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", 
											edgeFile = "Interface\\Buttons\\WHITE8x8", 
											tile = true, tileSize = self.fPaddingOut, edgeSize = self.fPaddingOut, 
											insets = { left = self.fPaddingOut, right = self.fPaddingOut, top = self.fPaddingOut, bottom = self.fPaddingOut }});
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:SetBackdropColor(0,0,0,1)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:SetBackdropBorderColor(0.2,0.2,0.2,1)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon = JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:CreateTexture()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetSize(self.db.global.iFontSize, self.db.global.iFontSize);
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetPoint("TOPLEFT", self.fPadding, -self.fPadding)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexCoord(0.1, 0.9, 0.1, 0.9)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES");
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexCoord(0,0,0,0);
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame = CreateFrame("Frame", "JeypLoathebHealSorter_Frame_" .. iID.."_SporeFrame", JeypLoathebHealSorter_Frame.tHealersFrames[iID])
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:SetSize(self.db.global.iFontSize + (self.fPadding * 2), self.db.global.iFontSize + (self.fPadding * 2));
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:SetPoint("TOPLEFT", JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame, "TOPRIGHT", self.db.global.iMargin, 0);
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8", 
											edgeFile = "Interface\\Buttons\\WHITE8x8", 
											tile = true, tileSize = self.fPaddingOut, edgeSize = self.fPaddingOut, 
											insets = { left = self.fPaddingOut, right = self.fPaddingOut, top = self.fPaddingOut, bottom = self.fPaddingOut }});
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:SetBackdropColor(0,0,0,1)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:SetBackdropBorderColor(0.2,0.2,0.2,1)
		
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexSporeIcon = JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:CreateTexture()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexSporeIcon:SetSize(self.db.global.iFontSize, self.db.global.iFontSize);
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexSporeIcon:SetPoint("TOPLEFT", self.fPadding, -self.fPadding)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexSporeIcon:SetTexCoord(0.1, 0.9, 0.1, 0.9)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexSporeIcon:SetTexture("Interface\\Icons\\spell_nature_unyeildingstamina");
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic = JeypLoathebHealSorter_Frame.tHealersFrames[iID]:CreateFontString("JeypLoathebHealSorter_Frame_" .. iID .. "_Text", 'ARTWORK');
		if self.db.global.sFont ~= nil then
			JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:SetFont(LSM:Fetch("font", self.db.global.sFont), self.db.global.iFontSize)
		else
			JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:SetFontObject(NumberFontNormalSmall)
		end
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:SetTextHeight(self.db.global.iFontSize)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:SetPoint("TOPLEFT", JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexSporeIcon, "TOPRIGHT", self.db.global.iMargin, 0);	
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:SetText("|cFFFFFFFF" .. sText, 0, 0)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:SetJustifyH("LEFT")
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic.sStaticText = sText
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer = JeypLoathebHealSorter_Frame.tHealersFrames[iID]:CreateFontString("JeypLoathebHealSorter_Frame_" .. iID .. "_Player", 'ARTWORK');
		if self.db.global.sFont ~= nil then
			JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:SetFont(LSM:Fetch("font", self.db.global.sFont), self.db.global.iFontSize)
		else
			JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:SetFontObject(NumberFontNormalSmall)
		end
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:SetTextHeight(self.db.global.iFontSize)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:SetPoint("TOPLEFT", JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic, "TOPRIGHT", self.db.global.iMargin, 0);	
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:SetText(" ", 0, 0)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:SetJustifyH("LEFT")
		JeypLoathebHealSorter_Frame.tHealersFrames[iID]:SetHeight(JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:GetStringHeight())	
	else
		JeypLoathebHealSorter_Frame.tHealersFrames[iID]:Show()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].ClassFrame:Show()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].SporeFrame:Show()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:Show()
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:Show()
	end
	return JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:GetStringHeight() + self.db.global.iMargin
end

function JeypLoathebHealSorter:ReloadFrame(iPreviousCount, iNewCount)
	self:AddToLogFn("ReloadFrame") 
	
	if (iPreviousCount < iNewCount) then 
		local fHeight = JeypLoathebHealSorter_Frame:GetHeight()	
		for i = iPreviousCount + 1, iNewCount do 
			fHeight = fHeight + self:ShowHealerFrame(i, JeypLoathebHealSorter_Frame.tHealersFrames[i - 1])
		end
		JeypLoathebHealSorter_Frame:SetHeight(fHeight)
	elseif (iPreviousCount > iNewCount) then
		local fHeight = JeypLoathebHealSorter_Frame:GetHeight()	
		for i = iPreviousCount, iNewCount + 1, -1 do 
			fHeight = fHeight - self:HideHealerFrame(i)
		end
		JeypLoathebHealSorter_Frame:SetHeight(fHeight)
	else
		local fHeight = JeypLoathebHealSorter_Frame:GetHeight()	
		local rFrameAnchor = JeypLoathebHealSorter_Frame.tTextTitle
		for i = 1, iNewCount do 
			JeypLoathebHealSorter_Frame.tHealersFrames[i]:SetPoint("TOP",rFrameAnchor,"BOTTOM", 0, -self.db.global.iMargin)	
			JeypLoathebHealSorter_Frame.tHealersFrames[i].SporeFrame:SetPoint("TOPLEFT", JeypLoathebHealSorter_Frame.tHealersFrames[i].ClassFrame, "TOPRIGHT", self.db.global.iMargin, 0);
			JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic:SetPoint("TOPLEFT", JeypLoathebHealSorter_Frame.tHealersFrames[i].tTexSporeIcon, "TOPRIGHT", self.db.global.iMargin, 0);	
			JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextPlayer:SetPoint("TOPLEFT", JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextStatic, "TOPRIGHT", self.db.global.iMargin, 0);	
			rFrameAnchor = JeypLoathebHealSorter_Frame.tHealersFrames[i]
			
			fHeight = fHeight + JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextPlayer:GetStringHeight() + self.db.global.iMargin
		end
		JeypLoathebHealSorter_Frame:SetHeight(fHeight)
	end
	self:UpdateFrame()
	self:UpdateFontSize()	
end

function JeypLoathebHealSorter:ReLoadHealerList()
	if self.iLastHealerList ~= nil then
		self:LoadHealerList(self.iLastHealerList.iTimestamp, self.iLastHealerList.message, self.iLastHealerList.sender)
	end
end

function JeypLoathebHealSorter:LoadSeparator(iTimestamp, message, sender)
	--print("LoadSeparator")
	self:AddToLogFn("LoadSeparator") 
	if not (UnitIsGroupAssistant(sender) or UnitIsGroupLeader(sender)) then 
		--print("Failed Leader", UnitIsGroupAssistant(sender), UnitIsGroupLeader(sender))
		self:AddToLogFn("LoadSeparator", "Canceled as " .. sender .. " Is not leader/assist") 
		return
	end
	
	if not self.bRunningTests then
		if self.iGreatestTimestampSeparator > iTimestamp then 
			--print("Failed Timestamp", iGreatestTimestampSeparator, iTimestamp)
			self:AddToLogFn("LoadSeparator", "Canceled as timestamp " .. iTimestamp .. " is lower than current timestamp " .. self.iGreatestTimestampSeparator)
			return
		end
	end
	
	--print("LoadSeparator", iTimestamp, message, sender)
	self.iGreatestTimestampSeparator = iTimestamp

	self.sRaidSeparator = message
	
	self:ReLoadHealerList()
	self:UpdateFrame()	
end

function JeypLoathebHealSorter:LoadHealerList(iTimestamp, message, sender)
	--print("LoadHealerList")
	self:AddToLogFn("LoadHealerList") 
	if not (UnitIsGroupAssistant(sender) or UnitIsGroupLeader(sender)) then 
		--print("Failed Leader", UnitIsGroupAssistant(sender), UnitIsGroupLeader(sender))
		self:AddToLogFn("LoadHealerList", "Canceled as " .. sender .. " Is not leader/assist")
		return
	end
	
	if not self.bRunningTests then
		if self.iGreatestTimestamp > iTimestamp then 
			--print("Failed Timestamp", self.iGreatestTimestamp, iTimestamp, sender)
			self:AddToLogFn("LoadHealerList", "Canceled as timestamp " .. iTimestamp .. " is lower than current timestamp " .. self.iGreatestTimestamp)
			return
		elseif self.iGreatestTimestamp == iTimestamp then
			if self.bReadyForReset then
				self.bReadyForReset = false
			else
				--print("Failed Timestamp (Equal)", self.iGreatestTimestamp, iTimestamp, sender)
				self:AddToLogFn("LoadHealerList", "Canceled as timestamp " .. iTimestamp .. " is same as current timestamp but hasn't gone out of combat")
				return
			end
		end
	end
	--print("LoadHealerList", iTimestamp, message, sender)
	self.iGreatestTimestamp = iTimestamp

	local sSeparator = self.sRaidSeparator or ","

	local tHealerList = self:SplitString(string.gsub(message or "", "%s+", ""), sSeparator)
	
	local bFirstHealerInCD = false
	if (#tHealerList > 0) then 
		self.iLastHealerList = {
			iTimestamp = iTimestamp,
			message = message,
			sender = sender,
		}
		self.tPreviousHealerList = self.tHealerList
		
		self.tHealerList = {}
		self.tHealerOrder = {}
		local sFirstPlayer = nil
		local sPrevPlayer = nil
		local sUpperPlayer = nil
		for i, sPlayer in ipairs(tHealerList) do 
			sUpperPlayer = string.upper(sPlayer)
			if self.tHealerList[sUpperPlayer] == nil and (UnitInRaid(sUpperPlayer) or not self.db.global.bIgnoreNonParty) then
				if sFirstPlayer == nil then 
					sFirstPlayer = sUpperPlayer
				end
				self.tHealerList[sUpperPlayer] = {
					bIsDead = UnitIsDeadOrGhost(sUpperPlayer),
					bCanCast = true,
					bNotInRaid = not UnitInRaid(sUpperPlayer) and not self.bRunningTests,
					fCooldownEnd = 0,
					sNextPlayer = sFirstPlayer,
					sAddonVersionID = "Unknown",
					sNameWithCase = sPlayer,
				}
				
				if sPrevPlayer ~= nil then
					self.tHealerList[sPrevPlayer].sNextPlayer = sUpperPlayer
				end
				sPrevPlayer = sUpperPlayer
			end
		end
		self.tHealerOrder[1] = string.upper(tHealerList[#tHealerList])
		
		for sPlayer, tPlayerData in pairs(self.tPreviousHealerList) do 
			if self.tHealerList[sPlayer] ~= nil then 
				self.tHealerList[sPlayer].sAddonVersionID = self.tPreviousHealerList[sPlayer].sAddonVersionID
					
				if not self.tPreviousHealerList[sPlayer].bCanCast then 
					self.tHealerList[sPlayer].bCanCast = false
					self.tHealerList[sPlayer].fCooldownEnd = self.tPreviousHealerList[sPlayer].fCooldownEnd
					if sPlayer == self.tHealerOrder[1] then 
						bFirstHealerInCD = true
					end
				end
			end
		end
	end
	
	self.tNonHealerList = {}
	self.tNonHealerOrder = {}
	for i=1,40 do 
		local sUnit = "raid" .. i
		local sUnitName = UnitName(sUnit)
		if sUnitName ~= nil then
			local sUnitClass = select(2, UnitClass(sUnit))
			local sUpperUnitName = string.upper(sUnitName)
			if self.tHealerList[sUpperUnitName] == nil and (sUnitClass == "SHAMAN" or sUnitClass == "PRIEST" or sUnitClass == "DRUID" or sUnitClass == "PALADIN") then
				self.tNonHealerList[sUpperUnitName] = {
					bIsDead = UnitIsDeadOrGhost(sUpperUnitName),
					bCanCast = true,
					bNotInRaid = not UnitInRaid(sUpperUnitName) and not self.bRunningTests,
					fCooldownEnd = 0,
					sNameWithCase = sUnitName,
					bNonHeal = true,
				}
				table.insert(self.tNonHealerOrder, sUpperUnitName)
			end
		end
	end
	
	self:GoToNextPlayer(true)
end

function JeypLoathebHealSorter:LoadOrderUpdate(iTimestamp, message, sender)
	self:AddToLogFn("LoadOrderUpdate") 
	if not (UnitIsGroupAssistant(sender) or UnitIsGroupLeader(sender)) then 
		--print("Failed Leader", UnitIsGroupAssistant(sender), UnitIsGroupLeader(sender))
		self:AddToLogFn("LoadOrderUpdate", "Canceled as " .. sender .. " Is not leader/assist")
		return
	end

	if self.iGreatestTimestamp ~= iTimestamp then 
		--print("Failed Timestamp", self.iGreatestTimestamp, iTimestamp, sender)
		self:AddToLogFn("LoadOrderUpdate", "Canceled as timestamp " .. iTimestamp .. " is different from current timestamp " .. self.iGreatestTimestamp)
		return
	end

	local tHealerList = self:SplitString(string.gsub(message or "", "%s+", ""), ",")
	
	if (#tHealerList > 0) then 
		for i, sPlayerData in pairs(tHealerList) do 
			local sPlayerName, sPlayerTimestamp = string.split(":", sPlayerData)
			local fPlayerTimestamp = tonumber(sPlayerTimestamp) or 0
			self.tHealerOrder[i] = sPlayerName
			self.tHealerList[sPlayerName].fCooldownEnd = fPlayerTimestamp
		end
	end

	self:UpdateFrame()	
end

function JeypLoathebHealSorter:ShowAnchor() 
	self:ReloadBackdrop()
	JeypLoathebHealSorter_Frame:EnableMouse(true);
	JeypLoathebHealSorter_Frame:SetMovable(true);
	JeypLoathebHealSorter_Frame:RegisterForDrag("LeftButton")
	self.bAnchorVisible = true
	JeypLoathebHealSorter_Frame.tTextTitle:Show()
	JeypLoathebHealSorter_Frame:Show()
	JeypLoathebHealSorter_Frame:SetAlpha(1);
end

function JeypLoathebHealSorter:HideAnchor()
	self:ReloadBackdrop()
	JeypLoathebHealSorter_Frame:EnableMouse(false)
	JeypLoathebHealSorter_Frame:SetMovable(false)
	JeypLoathebHealSorter_Frame.tTextTitle:Hide()
	self.bAnchorVisible = false
end

function JeypLoathebHealSorter:ReloadBackdrop() 
	JeypLoathebHealSorter_Frame:SetBackdrop({bgFile = LSM:Fetch("background", self.db.global.sBackground), 
										edgeFile = LSM:Fetch("border", self.db.global.sBorder), 
										tile = false, tileSize = 16, edgeSize = 16, 
										insets = { left = 4, right = 4, top = 4, bottom = 4 }});
	JeypLoathebHealSorter_Frame:SetBackdropColor(self.db.global.tBackgroundColor.r,self.db.global.tBackgroundColor.g,self.db.global.tBackgroundColor.b,self.db.global.tBackgroundColor.a);
	JeypLoathebHealSorter_Frame:SetBackdropBorderColor(self.db.global.tBackgroundColor.r,self.db.global.tBorderColor.g,self.db.global.tBorderColor.b,self.db.global.tBorderColor.a);
end

function JeypLoathebHealSorter:ToggleAnchor() 
	if self.bAnchorVisible then 
		self:HideAnchor()
		self:DisableWindow(true)
		self:CheckIfActiveAlreadyPresent()
	else 
		self:ShowAnchor()
	end
end

function JeypLoathebHealSorter:UpdateFrame()
	local function fnDrawPlayerData(iID, sPlayer, sFormattedPlayer) 
		local sStaticText = JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic.sStaticText
		if sPlayer == JeypLoathebHealSorter.sPlayerName then 
			sStaticText = "|cFFFF0000" .. sStaticText
		end
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextStatic:SetText(sStaticText, 0, 0)
		JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTextPlayer:SetText(sFormattedPlayer, 0, 0)
		if sPlayer ~= nil then
			local coords = CLASS_ICON_TCOORDS[select(2, UnitClass(sPlayer))] -- get the coordinates of the class icon we want
			if coords == nil then 
				JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexture("Interface\\Icons\\Inv_misc_questionmark");
				JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexCoord(0.1, 0.9, 0.1, 0.9); -- cut out the region with our class icon according to coords
			else 
				JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexture("Interface\\GLUES\\CHARACTERCREATE\\UI-CHARACTERCREATE-CLASSES");
				JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexCoord(unpack(coords)); -- cut out the region with our class icon according to coords
			end
		else
			JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexClassIcon:SetTexCoord(0,0,0,0);
			JeypLoathebHealSorter_Frame.tHealersFrames[iID].tTexSporeIcon:SetTexCoord(0,0,0,0);
		end
	end
	
	local function fnGetNextPlayer(sLastPlayer, tPreviousHealers)
		tPreviousHealers[sLastPlayer] = true
		local sNewHealer = self:GetNextPlayer(sLastPlayer, tPreviousHealers)
		local sFormattedHealer = sNewHealer
		if sNewHealer ~= nil then
			sFormattedHealer = self:PlayerNameWithClassColor(self.tHealerList[sNewHealer].sNameWithCase)
		end
		
		return sNewHealer, sFormattedHealer
	end
	local tSelectedHealers = {}
	
	local sNextHealerName = nil
	if self.tHealerOrder[i] ~= nil then 
		sNextHealerName = self.tHealerList[self.tHealerOrder[1]].sNameWithCase
	end
	
	local sFormattedHealer = self:PlayerNameWithClassColor(sNextHealerName)
	fnDrawPlayerData(1, self.tHealerOrder[1], sFormattedHealer)
	
	local iNonHealerID = 1
	for i = 1, self.db.global.iHealersToDisplay - 1 do 
		if self.tHealerOrder[i] ~= nil then
			self.tHealerOrder[i+1], sFormattedHealer = fnGetNextPlayer(self.tHealerOrder[i], tSelectedHealers)
			if self.tHealerOrder[i+1] ~= nil then
				fnDrawPlayerData(i+1, self.tHealerOrder[i+1], sFormattedHealer)
			else
				fnDrawPlayerData(i+1, nil, "")
			end
		elseif self.db.global.bDisplayOtherRoles and (self.tNonHealerOrder[iNonHealerID] ~= nil) then
			local sNonHealerName = self.tNonHealerOrder[iNonHealerID]
			if sNonHealerName ~= nil then
				sFormattedHealer = self:PlayerNameWithClassColor(self.tNonHealerList[sNonHealerName].sNameWithCase)
				fnDrawPlayerData(i, sNonHealerName, sFormattedHealer)
			else
				fnDrawPlayerData(i, nil, "")
			end
			iNonHealerID = iNonHealerID + 1
		else
			fnDrawPlayerData(i+1, nil, "")
		end
	end
	
	self:UpdateTimers()
	self:UpdateFontSize()
end

function JeypLoathebHealSorter:UpdateTimers() 
	local sText = ""
	local function fnBuildPlayerString(tPlayersTable, sPlayer)
		if tPlayersTable[sPlayer] == nil then
			return "NIL"
		end
		
		local sPrefix = ""
		local sSuffix = ""
		if tPlayersTable[sPlayer].bIsDead then 
			sPrefix = "[DEAD] "
		elseif tPlayersTable[sPlayer].bNonHeal then
			sPrefix = "[DPS] "
		elseif not UnitInRaid(sPlayer) and not self.bRunningTests then
			tPlayersTable[sPlayer].bNotInRaid = true
			sPrefix = "[NOT IN RAID] "
		end
		
		if not tPlayersTable[sPlayer].bCanCast then 
			tPlayersTable[sPlayer].bNotInRaid = false
			sSuffix = " (CD : " .. math.floor(tPlayersTable[sPlayer].fCooldownEnd - GetServerTime() + 0.5) .. "s)"
		end
		
		return sPrefix .. self:PlayerNameWithClassColor(tPlayersTable[sPlayer].sNameWithCase) .. sSuffix
	end
	
	local bReupdateFrame = false
	for i = 1, self.db.global.iHealersToDisplay do 
		if JeypLoathebHealSorter_Frame.tHealersFrames[i] ~= nil then
			local tPlayersTable = nil
			local sPlayerName = nil
			if self.tHealerOrder[i] ~= nil then
				tPlayersTable = self.tHealerList
				sPlayerName = self.tHealerOrder[i]
			elseif self.db.global.bDisplayOtherRoles and (self.tNonHealerOrder[i - #self.tHealerOrder] ~= nil) then
				tPlayersTable = self.tNonHealerList
				sPlayerName = self.tNonHealerOrder[i - #self.tHealerOrder]
			end
			
			if tPlayersTable ~= nil and sPlayerName ~= nil then
				if self.bRunningTests then
					if tPlayersTable[sPlayerName].fCooldownEnd > 0 and ((tPlayersTable[sPlayerName].fCooldownEnd - GetServerTime()) < 0) then 
						tPlayersTable[sPlayerName].bCanCast = true
						tPlayersTable[sPlayerName].fCooldownEnd = 0
						bReupdateFrame = true
					end
				end
				if tPlayersTable[sPlayerName] ~= nil and tPlayersTable[sPlayerName].bHasCritBuff then 
					JeypLoathebHealSorter_Frame.tHealersFrames[i].tTexSporeIcon:SetTexCoord(0,1,0,1);
				else 
					JeypLoathebHealSorter_Frame.tHealersFrames[i].tTexSporeIcon:SetTexCoord(0,0,0,0);
				end
				JeypLoathebHealSorter_Frame.tHealersFrames[i].tTextPlayer:SetText(fnBuildPlayerString(tPlayersTable, sPlayerName), 0, 0)
			end
		end 
	end
	
	local fCurrentTime = GetServerTime()
	--print("ReadyForReset", self.bReadyForReset, self.fLastTimeInCombat)
	if not self.bReadyForReset then 
		if UnitAffectingCombat("player") or UnitHealth("player") == 0 then 
			self.fLastTimeInCombat = fCurrentTime
		else
			if self.fLastTimeInCombat + 10 < fCurrentTime then 
				self.bReadyForReset = true
			end
		end
	end
	
	if bReupdateFrame then 
		self:UpdateFrame() 
	end
end